-- Anglestand / Angleability --
-- i ported this code almost directly from VL_anglestand-v1.5.1.lua, don't blame me for the indentation

addHook("FollowMobj", function(player, followMob)
	local mo = player.mo
	if(mo.state == S_PLAY_ANGLEIDLE) then
		local newAngle = player.drawangle
		if(newAngle != nil) then
			P_TeleportMove(followMob, (mo.x - cos(newAngle)), (mo.y - sin(newAngle)), mo.z)
			followMob.angle = newAngle
			return true
		end
	end
end, MT_TAILSOVERLAY)

addHook("MobjThinker", function(mo)
	local player = mo.player
        local delayer = player.idleDelay
        if not player.idleDelay then
            delayer = 3*TICRATE
        end
		if player.playerstate == PST_LIVE then
			if player and player.AngleStand == "off" then
				if mo.state == S_PLAY_ANGLEIDLE then
					mo.state = S_PLAY_STND
				end
				return
			end
		
			-- prevents script from affecting strafe mode players
			-- only works in singleplayer
			if (player.strafeAnglestand == "on" and (not (player.pflags & !PF_FORCESTRAFE))) then
				if (mo.state == S_PLAY_ANGLEIDLE) then
					mo.state = S_PLAY_WAIT
					player.idlewait = 0
				end
				return
			end
			
			-- If nonIdle is true, later code will know not to trigger an idle animation.
			local nonIdle = 0
			if (player.powers[pw_super] or player.hypermysticsonic) then
				nonIdle = 1
			end
			local initialState = mo.state
			local followMob = mo.followmobj
			if player.prevdrawangle then
			
				-- special code for telekinetic hedgehogs
				if (mo.skin == "silver")
					if (mo.silv_telekinesis and #mo.silv_telekinesis)	-- Silver was, and might still be, holding something.
						mo.wasTelekinesis = true
						if (mo.silv_thrown and #mo.silv_thrown and not (#mo.silv_telekinesis > #mo.silv_thrown)) -- Silver isn't holding anything anymore.
							player.idlewait = 0
							mo.state = S_PLAY_STND
							mo.wasTelekinesis = false
						end
					elseif (mo.wasTelekinesis == true) then	-- Silver was holding something, but isn't anymore.
						player.idlewait = 0
						mo.state = S_PLAY_STND
						mo.wasTelekinesis = false
					elseif (initialState == S_PLAY_WAIT) then	-- Silver is in his idle animation. Because he only uses 1 frame for himself, he doesn't need to be using the custom idle state.
						player.drawangle = player.prevdrawangle
						mo.state = S_PLAY_WAIT			-- As a matter of fact, the custom idle state breaks his idle animation.
						player.idlewait = delayer
					elseif (initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART))) then
			
						player.drawangle = player.prevdrawangle
					
						-- initiates idle animation when the idlewait timer reaches its limit
							if(player.idlewait != nil)
								local idlewait = player.idlewait
								if(idlewait < delayer) then
									player.idlewait = $ + 1
								else
									if(idlewait < delayer + 1) then
										mo.state = S_PLAY_WAIT
									end
								end
						
							else
								player.idlewait = 1
							end
					elseif
					(
						mo.momx == 0
						and mo.momy == 0
						and
						(
							initialState == S_PLAY_JUMP
							or initialState == S_PLAY_EDGE
							or initialState == S_PLAY_FALL
							or initialState == S_PLAY_SPRING
							or initialState == S_PLAY_GASP
							or initialState == S_PLAY_FLOAT
						)
					) then
						player.drawangle = player.prevdrawangle
						player.idlewait = 0
						
					elseif (initialState == S_PLAY_ANGLEIDLE) then -- Fixes bug arising from swapping skins while in S_PLAY_ANGLEIDLE
						mo.state = S_PLAY_STND
						player.idlewait = delayer
						
					-- resets idle timer
					else
						player.idlewait = 0
					end
					-- end of Silver's code
					
				-- special code for Dirk
				elseif(mo.skin == "dirk")
					if(mo.dirk_idle >= 0)	-- Dirk is idling
						player.drawangle = player.prevdrawangle
						player.idlewait = delayer
					elseif(initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART)))
			
						player.drawangle = player.prevdrawangle
					
						-- initiates idle animation when the idlewait timer reaches its limit
							if(player.idlewait != nil)
								local idlewait = player.idlewait
								if(idlewait < delayer)
									player.idlewait = $ + 1
								else
									if(idlewait < delayer + 1)
										mo.state = S_PLAY_WAIT
									end
								end
						
							else
								player.idlewait = 1
							end
					elseif
					(
						mo.momx == 0
						and mo.momy == 0
						and
						(
							initialState == S_PLAY_JUMP
							or initialState == S_PLAY_EDGE
							or initialState == S_PLAY_FALL
							or initialState == S_PLAY_SPRING
							or initialState == S_PLAY_GASP
							or initialState == S_PLAY_FLOAT
						)
					)
						player.drawangle = player.prevdrawangle
						player.idlewait = 0
					
					elseif(initialState == S_PLAY_ANGLEIDLE) -- Fixes bug arising from swapping skins while in S_PLAY_ANGLEIDLE
						mo.state = S_PLAY_WAIT
						player.idlewait = delayer
					
					-- resets idle timer
					else
						player.idlewait = 0
					end
				-- end of Dirk's code
				
				-- For characters who shouldn't be going into an idle animation.
				elseif(nonIdle == 1)
					if
					(
						initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART))
						or
						(
							mo.momx == 0
							and mo.momy == 0
							and
							(
								initialState == S_PLAY_JUMP
								or initialState == S_PLAY_EDGE
								or initialState == S_PLAY_FALL
								or initialState == S_PLAY_SPRING
								or initialState == S_PLAY_GASP
								or initialState == S_PLAY_FLY
								or initialState == S_PLAY_FLY_TIRED
								or initialState == S_PLAY_GLIDE_LANDING
								or initialState == S_PLAY_SWIM
								or initialState == S_PLAY_TWINSPIN
								or initialState == S_PLAY_BOUNCE
								or initialState == S_PLAY_BOUNCE_LANDING
								or initialState == S_PLAY_FLOAT
							)
						)
					)
						player.drawangle = player.prevdrawangle
					end
				
				-- for everyone else
				-- swaps the default idle animation for the custom one, unless the skin is silver
				elseif (initialState == S_PLAY_WAIT) then
					mo.state = S_PLAY_ANGLEIDLE
					player.idlewait = delayer + 1
					
				elseif ((initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART))) or initialState == S_PLAY_ANGLEIDLE)
				
					player.drawangle = player.prevdrawangle
					
					-- initiates idle animation when the idlewait timer reaches its limit
					if(player.idlewait != nil and (nonIdle == 0) )
						local idlewait = player.idlewait
						if (idlewait < delayer) then
							player.idlewait = $ + 1
						else
							if(idlewait < delayer + 1)
								mo.state = S_PLAY_ANGLEIDLE
								player.idlewait = $ + 1
							end
						end
						
					else
						player.idlewait = 1
					end
				
				-- prevents autoturning when jumping, teetering, springing, or using a vanilla charcter air ability in place, then resets idle timer
				elseif
				(
					mo.momx == 0
					and mo.momy == 0
					and
					( --#### Note to self: look into alternate ways of doing this for the possibility of supporting custom abilities.
						initialState == S_PLAY_JUMP
						or initialState == S_PLAY_EDGE
						or initialState == S_PLAY_FALL
						or initialState == S_PLAY_SPRING
						or initialState == S_PLAY_GASP
						or initialState == S_PLAY_FLY
						or initialState == S_PLAY_FLY_TIRED
						or initialState == S_PLAY_GLIDE_LANDING
						or initialState == S_PLAY_SWIM
						or initialState == S_PLAY_TWINSPIN
						or initialState == S_PLAY_BOUNCE
						or initialState == S_PLAY_BOUNCE_LANDING
						or initialState == S_PLAY_FLOAT
						
						or (player.bunsFlightTime != nil and player.bunsFlightBegun != nil and player.bunsFlightTime > 0 and player.bunsFlightBegun == true)	-- Bunnie compatability
					)
				)
					player.drawangle = player.prevdrawangle
					player.idlewait = 0
					
				-- resets idle timer
				else
					player.idlewait = 0
				end
			end
			
		player.prevdrawangle = player.drawangle -- sets the angle for the player to maintain next frame
		
		if (initialState == S_PLAY_ANGLEIDLE and (player.rmomx != 0 or player.rmomy != 0))
			mo.state = S_PLAY_WALK		-- This line cancels idle animation when the player moves.
		elseif(initialState == S_PLAY_ANGLEIDLE and player.FallingAnimation == true and (not P_IsObjectOnGround(mo)) and (not (player.powers[pw_carry] == CR_ROLLOUT)))	--Falling Animation compatability
			if (mo.momz * P_MobjFlip(mo) < 0) then
				mo.state = S_PLAY_FALL
			else
				mo.state = S_PLAY_SPRING
			end
		end
	end
		
end, MT_PLAYER)