local mmtversion = "5.1"

local function mmtdebuggerPrint(player, text)
    --if player.mmtoptions[FindOption(player, "Debug")].set[1] == "on" then
        --CONS_Printf(player, text)
    --end
end

local function SaveOptions(player)
    local file = io.openlocal("client/mmtconf.cfg", "w")
    for n = 1, #mmt_MainMenu do -- For every entry in the main menu
        if mmt_MainMenu[n].jumptostring then -- All of the tables inside the main menu, which contain the actual options
            local tabler = mmt_ListOTables[mmt_MainMenu[n].jumptostring]
            if not tabler.textonly then
                for index = 1, #tabler do
                    local entry = tabler[index]
                    local default = entry.default
                    if entry.prop != nil and not entry.nosave then
                        if default == nil then
                            default = "Gooper Goop Goop" -- i don't remember why i've done this, but i'm not removing this because this is funny
                        end
                        if player[entry.prop] != entry.default then -- if entry is not default, then change it in options file; this is to save space and time
                            file:write("mmtload \"" + entry.name + "\" \"" + player[entry.prop] + "\" \"" + entry.prop + "\"" + "\n")
                            file:write("wait 1\n")
                        end
                    end
                end
            end
        end
    end
	file:write("mmtload MMTLOADCOMPLETE!!!")
	io.close(file)
	CONS_Printf(player, "[\x89" .. "MMT" .. "\x80]\x8C Config file saved to" .. "\x80: (\x81" .. "luafiles/client/mmtconf.cfg" .. "\x80)")
end

local function FindOption(player, name)
    for index, value in ipairs(player.mmtoptions) do
         if value.name == name then
              return index
         end
    end
end

local function FindDescription(player, optionid, name)
	for index, value in ipairs(player.mmtoptions[optionid].description) do
		 if value == name then
			  return index
		 end
	end
end

local function tablelength(T)
    local count = 0
    for _ in pairs(T) do count = count + 1 end
    return count
end

local function ConvertStringKey(key)
    if key == "custom1" then
        return BT_CUSTOM1
    elseif key == "custom2" then
        return BT_CUSTOM2
    elseif key == "custom3" then
        return BT_CUSTOM3
    elseif key == "spin" then
        return BT_SPIN
    elseif key == "jump" then
        return BT_JUMP
    elseif key == "tossflag" then
        return BT_TOSSFLAG
    elseif key == "ringtoss" then
        return BT_ATTACK
    elseif key == "ringtossnormal" then
        return BT_FIRENORMAL
    elseif key == "weaponnext" then
        return BT_WEAPONNEXT
    elseif key == "weaponprev" then
        return BT_WEAPONPREV
    end
end

rawset(_G, "mmtversion", mmtversion)
rawset(_G, "mmtdebuggerPrint", mmtdebuggerPrint)
rawset(_G, "MMT_SaveOptions", SaveOptions)
rawset(_G, "mmt_FindOption", FindOption)
rawset(_G, "mmt_FindDescription", FindDescription)
rawset(_G, "mmt_tablelength", tablelength)
rawset(_G, "mmt_ConvertStringKey", ConvertStringKey)