--[[
                                                                                    .   .
                                                                                  ..   ..
                                                                                ...   ...
                                                                             .............
                                                                         .................
                                                  @@@@@@@@@...............................
                                       @@@@@@@@@@@@@@@@..................................
                               @@@@@@@@@@@@@@@@@@........................................
                          @@@@@@@@@@@@@@@@@..............................................
                      @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@............................
                   @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@...............................
                 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.......@@@@@@@@@@...................
               @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@......................
             @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.......................
            @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@...........................
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.................
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@..................
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.......@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@.........
           @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@....@@@...
            @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@....
             @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@....
              @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@...@
               @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                      @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                            @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                               @@@@@@@@@@@@@@@@@@@@@@@
                                      @@@@@@@@@@
]]

local OnOff = {"on", "off"}
local CommonKeys = {"spin", "custom1", "custom2", "custom3", "tossflag", "ringtoss", "ringtossnormal", "off"}


-- literally just in here for the sake of playing sounds lmao
-- should've made this a globally accessible table thing instead smh

local JumpTable = {
    ["Sonic 1"] = sfx_s1a0,
    ["Sonic 2"] = sfx_s220,
    ["Sonic CD"] = sfx_cdfm02,
    ["Sonic 3K"] = sfx_s3k62,
    ["Knuckles' Chaotix"] = sfx_kc5f,
    ["NiGHTS"] = sfx_ngjump,
    ["Super Mario Bros."] = sfx_mario6,
}

local SkiddingTable = {
    ["Sonic 1"] = sfx_s1a4,
    ["Sonic 2"] = sfx_s224,
    ["Sonic 3K"] = sfx_s3k36,
    ["Sonic CD"] = sfx_cdfm00,
    ["Knuckles' Chaotix"] = sfx_kc2b,
}

local PutPutTable = {
    ["Sonic 3K"] = sfx_s3kba,
}
local PudPudTable = {
    ["Sonic 3K"] = sfx_s3kbb,
}

local SpikesTable = {
    ["Sonic 1"] = sfx_s1a6,
    ["Sonic 2"] = sfx_s226,
    ["Sonic 3K"] = sfx_s3k37,
}

local DeathTable = { -- ominous name
    ["Sonic 1"] = sfx_s1a3,
    ["Sonic 2"] = sfx_s223,
    ["Sonic CD"] = sfx_cdfm03,
    ["Sonic 3K"] = sfx_s3k35,
    ["Knuckles' Chaotix"] = sfx_kc58,
}

local SpinningTable = {
    ["Sonic 1"] = sfx_s1be,
    ["Sonic 2"] = sfx_s23e,
    ["Sonic CD"] = sfx_cdfm12,
    ["Sonic 3K"] = sfx_s3k3c,
    ["Knuckles' Chaotix"] = sfx_cdfm12,
}

local SpindashTable = {
    ["Sonic 2"] = sfx_s260,
    ["Sonic CD"] = sfx_cdfm11,
    ["Sonic 3K"] = sfx_s3kab,
    ["Knuckles' Chaotix"] = sfx_kc6c, 
}

local SpinzoomTable = {
    ["Sonic 2"] = sfx_s23c,
    ["Sonic CD"] = sfx_cdfm01,
    ["Sonic 3K"] = sfx_s3kb6,
    ["Knuckles' Chaotix"] = sfx_kc3c,
}

local GaspTable = {
    ["Sonic 1"] = sfx_s1ad,
    ["Sonic 2"] = sfx_s22d,
    ["Sonic CD"] = sfx_cdfm29,
    ["Sonic 3K"] = sfx_s3k38,
}

local DrownTable = {
    ["Sonic 1"] = sfx_s1b2,
    ["Sonic 2"] = sfx_s232,
    ["Sonic CD"] = sfx_cdfm38,
    ["Sonic 3K"] = sfx_s3k3b,
}

local SpringTable = {
    ["Sonic 1"] = sfx_s1cc,
    ["Sonic 2"] = sfx_s1cc,
    ["Sonic 3K"] = sfx_s3kb1,
    ["Sonic CD"] = sfx_cdfm08,
    ["Knuckles' Chaotix"] = sfx_kc2f
}


local mmt_ControlsMenu = {
    {
		name = "Spin Steering",
		description = "Adjusts your ability to steer while spinning. Set to 0 to disable.",
        range = {0, 20},
        default = 0,
		prop = "spinsteer",
	},
    {
		name = "Mid-Air Controls",
        hidename = true,
		description = "Apply the spin steering to mid-air controls?",
        stringoptions = {"off", "lightest", "lighter", "normal"},
        default = "lighter",
		prop = "spstmidair",
	},
    {
		name = "Recurl",
		description = "Re-curl into a ball in mid-air using this key.",
        stringoptions = {"spin", "jump", "off"},
        default = "spin",
		prop = "recurl",
	},
    {
		name = "Uncurl",
		description = "While going fast while spinning, pressing spin again will uncurl you.",
        stringoptions = OnOff,
        default = "off",
		prop = "uncurl",
	},
    {
		name = "Tails Drop Ball",
		description = "Allow Tails to curl up into a ball mid-flight using this key.",
        stringoptions = CommonKeys,
        default = "off",
		prop = "tailsball",
	},
    {
		name = "Hold Fly",
		description = "As Tails, hold down the fly button to keep flying.",
        stringoptions = OnOff,
        default = "off",
		prop = "holdfly",
	},
    {
		name = "Run On Water",
		description = "Allows the player to run on water when they get enough speed.",
        stringoptions = OnOff,
        default = "off",
		prop = "waterrunner",
	},
    {
		name = "RoW Speed Additions",
        hidename = true,
		description = "Speed required on top of regular running speed to run on water.",
        range = {0, 30},
        default = 0*FRACUNIT,
        multiplier = FRACUNIT,
		prop = "rowreq",
	},
    {
		setto = "Next Page",
        font = "normal",
        jumptostring = "mmt_ControlsMenu2",
	},
}
mmt_ControlsMenu.submenu = true
mmt_ControlsMenu.title = "Controls"
mmt_ControlsMenu.subtitles = {"Page 1"}

local mmt_ControlsMenu2 = {
    {
		name = "Coyote Time",
		description = "Grants you a split-second to jump while in mid-air.",
        stringoptions = OnOff,
        default = "on",
		prop = "CoyoteTime",
	},
    {
		name = "Recovery Jump",
		description = "Allows you to jump shortly after taking damage.",
        stringoptions = OnOff,
        default = "off",
		prop = "RecoveryJump",
	},
    {
		name = "Speedier Spin",
		description = "If you're super or have super sneakers, spindashes go faster.",
        stringoptions = OnOff,
        default = "on",
		prop = "speedierspin",
	},
    {
		setto = "Previous Page",
        font = "normal",
        jumptostring = "mmt_ControlsMenu",
	},
}
mmt_ControlsMenu2.submenu = true
mmt_ControlsMenu2.title = "Controls"
mmt_ControlsMenu2.subtitles = {"Page 2"}

local mmt_EnhancementsMenu = {
    {
		name = "Preserve Shields",
		description = "Carry over shields between acts.",
        stringoptions = OnOff,
        default = "on",
		prop = "preserveshield",
	},
    {
		name = "Preserve Shields between Zones",
        hidename = true,
		description = "Preserve shield between zones too?",
        stringoptions = OnOff,
        default = "off",
		prop = "preserveshieldzones",
	},
    {
		name = "Fade Music",
		description = "Fade the music when you clear a level.",
        stringoptions = OnOff,
        default = "on",
		prop = "MMTfademusic",
	},
    {
		name = "Token to Rings",
		description = "With 7 emeralds, emerald tokens grant 50 rings when collected.",
        stringoptions = OnOff,
        default = "on",
		prop = "TokenToRings",
	},
    {
		name = "Angle Stand",
		description = "Stops character from turning when the camera angle turns.",
        stringoptions = OnOff,
        default = "off",
		prop = "AngleStand",
	},
    {
		name = "Autoturn Cancel",
        hidename = true,
		description = "Autoturn cancelling applies to strafe mode.",
        stringoptions = OnOff,
        default = "on",
		prop = "strafeAnglestand",
	},
	{
		name = "Idle Delay",
        hidename = true,
		description = "Amount of time before player enters idle animation.",
		prop = "idleDelay",
		range = {1, 10},
		default = 3*TICRATE,
        multiplier = TICRATE,
	},
    {
		name = "Speedy Particles",
		description = "Spawns dust particles when you're going fast!",
        stringoptions = OnOff,
        default = "on",
		prop = "speedyparts",
	},
    {
		name = "Flaming Particles",
        hidename = true,
		description = "Spawn fire particles when you're going really fast!",
        stringoptions = OnOff,
        default = "off",
		prop = "speedyflames",
	},
    {
		setto = "Next Page",
        font = "normal",
        jumptostring = "mmt_EnhancementsMenu2",
	},
}
mmt_EnhancementsMenu.submenu = true
mmt_EnhancementsMenu.title = "Enhancements"
mmt_EnhancementsMenu.subtitles = {"Page 1"}

local mmt_EnhancementsMenu2 = {
    {
		name = "Fall Off Edge Animation",
		description = "Prevents the walking animation from playing when in air.",
        stringoptions = OnOff,
        default = "off",
		prop = "noairwalk",
	},
    {
		name = "Spring Twirl",
		description = "Causes the player to twirl when using a spring, ala Sonic CD.",
        stringoptions = OnOff,
        default = "off",
		prop = "SpringTwirlOption",
	},
    {
		name = "Always Render Shields",
		description = "Renders your shield if you're invincible/super.",
        stringoptions = OnOff,
        default = "off",
		prop = "MMTsupershield",
	},
    {
		name = "Decrease Ring Scattering",
		description = "Make rings no longer scatter farther when you get hit multiple times.",
        stringoptions = OnOff,
        default = "off",
		prop = "ringscatter",
	},
    {
		setto = "Previous Page",
        font = "normal",
        jumptostring = "mmt_EnhancementsMenu",
	},
}
mmt_EnhancementsMenu2.submenu = true
mmt_EnhancementsMenu2.title = "Enhancements"
mmt_EnhancementsMenu2.subtitles = {"Page 2"}

local mmt_SuperFormMenu = {
    {
		name = "Super Button",
		description = "Change the button used to go super.",
        stringoptions = CommonKeys,
        default = "spin",
		prop = "superkey",
	},
    {
		name = "Disable Super Music",
		description = "(requires Super Button) Disables the super form music from playing.",
        stringoptions = OnOff,
        default = "off",
		prop = "supermusic",
	},
    {
		name = "Cancel Super",
		description = "Button to cancel your super form.",
        stringoptions = CommonKeys,
        default = "custom1",
		prop = "cancelsuperkey",
	},
    {
		name = "Super 4 All",
		description = "Allow super forms for all characters?",
        stringoptions = OnOff,
        default = "on",
		prop = "super4all",
	},
    {
		name = "Super Trails",
		description = "Give the player a ghost behind them when going super.",
        stringoptions = OnOff,
        default = "on",
		prop = "supertrails",
	},
    {
		name = "Disable Super Hover",
		description = "Disable the ability to hover as Super Sonic.",
        stringoptions = OnOff,
        default = "off",
		prop = "disablesuperhover",
	},

}
mmt_SuperFormMenu.submenu = true
mmt_SuperFormMenu.title = "Super Form Options"

local mmt_SoundsMenu = {
    {
		name = "Sound FX Set",
		description = "Changes all of your sound effects, and ignores other SFX options.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K", "Knuckles' Chaotix"},
        default = "off",
		prop = "mmtsfxset",
	},
    {
		name = "Jump",
		description = "Changes the jump sound.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K", "NiGHTS", "Super Mario Bros."},
        soundz = JumpTable,
        default = "off",
		prop = "mmtsfxjump",
	},
    {
		name = "Skidding",
		description = "Changes the skidding SFX.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K", "Knuckles' Chaotix"},
        soundz = SkiddingTable,
        default = "off",
		prop = "mmtsfxskidding",
	},
    {
		name = "Tails Flight",
		description = "Changes the PutPut/PudPud SFX.",
        stringoptions = {"off", "Sonic 3K"},
        soundz = PutPutTable,
        default = "off",
		prop = "mmtsfxflight",
	},
    {
		name = "Death",
		description = "Changes the death sound.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K", "Knuckles' Chaotix"},
        soundz = DeathTable,
        default = "off",
		prop = "mmtsfxded",
	},
    {
		name = "Spikes",
		description = "Changes the hit by spikes sound.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic 3K"},
        soundz = SpikesTable,
        default = "off",
		prop = "mmtsfxspikes",
	},
    {
		setto = "Next Page",
        font = "normal",
        jumptostring = "mmt_SoundsMenu2",
	},
}
mmt_SoundsMenu.submenu = true
mmt_SoundsMenu.title = "SFX Style"
mmt_SoundsMenu.subtitles = {"Page 1", "Press " .. "\x81" .. "jump" .. "\x80" .. " to preview the sound!"}

local mmt_SoundsMenu2 = {
    {
		name = "Spindash",
		description = "Changes the spindash SFX.",
        stringoptions = {"off", "Sonic 2", "Sonic CD", "Sonic 3K", "Knuckles' Chaotix"},
        soundz = SpindashTable,
        default = "off",
		prop = "mmtsfxspindash",
	},
    {
		name = "Spindash Release",
		description = "Changes the spindash zoom SFX.",
        stringoptions = {"off", "Sonic 2", "Sonic CD", "Sonic 3K", "Knuckles' Chaotix"},
        soundz = SpinzoomTable,
        default = "off",
		prop = "mmtsfxspinzoom",
	},
    {
		name = "Spinning",
		description = "Changes the spinning SFX.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K"},
        soundz = SpinningTable,
        default = "off",
		prop = "mmtsfxspinning",
	},
    {
		name = "Spring",
		description = "Changes the spring SFX. Probably won't work on custom springs!",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K", "Knuckles' Chaotix"},
        soundz = SpringTable,
        default = "off",
		prop = "mmtsfxspring",
	},
    {
		name = "Gasp",
		description = "Changes the getting air bubble SFX.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K"},
        soundz = GaspTable,
        default = "off",
		prop = "mmtsfxgasp",
	},
    {
		name = "Drowning",
		description = "Changes the drowning SFX.",
        stringoptions = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K"},
        soundz = DrownTable,
        default = "off",
		prop = "mmtsfxdrowning",
	},
    {
		setto = "Previous Page",
        font = "normal",
        jumptostring = "mmt_SoundsMenu",
	},
}
mmt_SoundsMenu2.submenu = true
mmt_SoundsMenu2.title = "SFX Style"
mmt_SoundsMenu2.subtitles = {"Page 2", "Press " .. "\x81" .. "jump" .. "\x80" .. " to preview the sound!"}

local mmt_PlayerMenu = {
    {
		name = "Character",
		description = "Changes your character!",
        range = {-1, #skins-1},
        default = -1,
		prop = "mmtplayerskin",
        nonetgame = true,
        nosave = true,
	},
    {
		name = "Color",
		description = "Changes your character's color!",
        range = {0, #skincolors-1},
        default = 0,
		prop = "mmtplayercolor",
        nonetgame = true,
	},
}
mmt_PlayerMenu.submenu = true
mmt_PlayerMenu.colorsmenu = true -- 2lazy2changename
mmt_PlayerMenu.title = "Customize Player Menu"
mmt_PlayerMenu.subtitles = {"\x82" .. "NOTICE! Custom colors and characters needs to be loaded before MMT!", "Press " .. "\x81" .. "jump" .. "\x80" .. " to reset the value."}

local mmt_MiscMenu = {
    {
		name = "Deaths Counter",
		description = "Replaces your lives with a death counter.",
        stringoptions = {"reset after level", "off", "on"},
        default = "off",
		prop = "deathscounter",
	},
    {
		name = "Deaths Counter Show/Hide",
        hidename = true,
		description = "Always show, or hide deaths counter after start?",
        stringoptions = {"show", "hide"},
        default = "show",
		prop = "MMTdcvis",
	},
    {
		name = "Score-Based Continues",
		description = "With enough points, player is granted a continue.",
        stringoptions = OnOff,
        default = "off",
		prop = "scorecontinues",
        nonetgame = true,
	},
    {
		name = "Classic Shields",
		description = "Changes the SRB2 shields to their S3K equivalents.",
        stringoptions = OnOff,
        default = "off",
		prop = "classicshields",
        nonetgame = true,
	},
    {
		name = "Instant Respawn",
		description = "Instantly respawns the player when they die.",
        stringoptions = OnOff,
        default = "off",
		prop = "instantrespawn",
	},
    {
		name = "Menu Music",
		description = "Plays music when you open the MMT menu!",
        stringoptions = OnOff,
        default = "on",
		prop = "menumusic",
	},

}
mmt_MiscMenu.submenu = true
mmt_MiscMenu.title = "Misc. Options"

local mmt_Credits = { -- very janky stuff going on here to do this
    {
        setto = "TrustyGun: Spring Twirl",
		description = "mb.srb2.org/addons/1213/",
	},
    {
        setto = "ffoxD: Spin Steer",
		description = "mb.srb2.org/addons/1429/",
	},
    {
        setto = "Kirb: Air walk remover",
		description = "mb.srb2.org/addons/2815/",
	},
    {
        setto = "Krabs and Stonecutter: Anglestand",
		description = "mb.srb2.org/addons/1342/",
	},
    {
        setto = "TehRealSalt: Jump Leniency",
		description = "mb.srb2.org/addons/2821/",
	},
    {
        setto = "Lianvee: Personal Sounds",
		description = "mb.srb2.org/addons/2924/",
	},
    {
        setto = "amperbee: PBT3, help on menu system",
        description = "mb.srb2.org/members/5188/"
	},
    {
        setto = "(music) Yuji Takenouchi - Pro Baseball News",
		description = "vgmrips.net/packs/pack/namachuukei-68-sharp-x68000",
	},

}
mmt_Credits.title = "Credits"
mmt_Credits.submenu = true
mmt_Credits.textonly = true
mmt_Credits.subtitles = {"Descriptions show the associated URL."}

local mmt_MainMenu = {
    {
		name = "Controls",
		description = "Changes your controls.",
        jumptostring = "mmt_ControlsMenu"
	},
    {
		name = "Enhancements",
		description = "Adds flairs, effects, and other adjustments to the game.",
        jumptostring = "mmt_EnhancementsMenu"
	},
    {
		name = "Super Form Options",
		description = "Changes settings around going super.",
        jumptostring = "mmt_SuperFormMenu"
	},
    {
		name = "SFX Style",
		description = "Customizes your player's sound effects.",
        jumptostring = "mmt_SoundsMenu"
	},
    {
		name = "Customize Player",
		description = "Changes your character's properties in single-player.",
        jumptostring = "mmt_PlayerMenu",
        nonetgame = true,
	},
    {
		name = "Misc. Options",
		description = "Other options that don't fit anywhere else.",
        jumptostring = "mmt_MiscMenu"
	},
    {
		name = "Credits",
		description = "Displays the credits for this mod.",
        jumptostring = "mmt_Credits"
	},
    {
		name = "Controls Menu Page 2",
		description = "you shouldn't be able to see this, what have you done",
        hide = true,
        jumptostring = "mmt_ControlsMenu2"
	},
    {
		name = "Enhancements Menu Page 2",
		description = "you shouldn't be able to see this, what have you done",
        hide = true,
        jumptostring = "mmt_EnhancementsMenu2"
	},
    {
		name = "SFX Menu Menu Page 2",
		description = "you shouldn't be able to see this, what have you done",
        hide = true,
        jumptostring = "mmt_SoundsMenu2"
	},
}
mmt_MainMenu.title = "\x89" .. "M" .. "\x80" .. "any " .. "\x89" .. "M" .. "\x80" .. "inor " .. "\x89" .. "T" .. "\x80" .. "weaks Menu"
mmt_MainMenu.subtitles = {"Press " .. "\x81" .. "jump" .. "\x80" .. " to enter a menu, and press " .. "\x81" .. "spin" .. "\x80" .. " to exit a menu.",
"Press " .. "\x81" .. "left" .. "\x80" .. " or " .. "\x81" .. "right" .. "\x80" .. " to change an option."}
mmt_MainMenu.mainmenu = true

rawset(_G, "mmt_MainMenu", mmt_MainMenu)

local mmt_ListOTables = { -- because frankly i give up my guys, srb2's netgame code fucking sucks why doesn't it accept player tables aghhhh
["mmt_MainMenu"] = mmt_MainMenu,
["mmt_MiscMenu"] = mmt_MiscMenu,
["mmt_SuperFormMenu"] = mmt_SuperFormMenu,
["mmt_SoundsMenu"] = mmt_SoundsMenu,
["mmt_SoundsMenu2"] = mmt_SoundsMenu2,
["mmt_EnhancementsMenu"] = mmt_EnhancementsMenu,
["mmt_EnhancementsMenu2"] = mmt_EnhancementsMenu2,
["mmt_ControlsMenu"] = mmt_ControlsMenu,
["mmt_PlayerMenu"] = mmt_PlayerMenu,
["mmt_ControlsMenu2"] = mmt_ControlsMenu2,
["mmt_Credits"] = mmt_Credits,
}

rawset(_G, "mmt_ListOTables", mmt_ListOTables)

addHook("PreThinkFrame", function()
    for player in players.iterate do
        pbtDaemonmmt(player)
        if player and (player.mmtusingmenu or player.mmenuWaitUntilLetGo) then
            player.cmd.forwardmove = 0
            player.cmd.sidemove = 0
            player.cmd.buttons = 0
        end
        if player.mmtbt.spin > 0 and (player.pflags & PF_SPINNING) == 0 then -- random bit from uncurl here, because it doesn't work in regular thinkframe >:(
            player.denyuncurl = true
        end
    end
end)

local FixCharacterSkin = false

addHook("ThinkFrame", function()
    if not FixCharacterSkin then -- need to do this since the skins table isn't properly initialized on load
        if #skins > 0 then -- just to be extra sure
            for index, value in ipairs(mmt_PlayerMenu) do
                if value.name == "Character" then
                    value.range = {-1, #skins-1}
                    FixCharacterSkin = true
                end
            end
        end
    end

    for player in players.iterate do
        --local player = mo.player
        if not (player and player.valid) then break end -- player does not exist, don't run
        if not (player.realmo and player.realmo.valid) then break end -- player does not exist 2: revengence, don't run
        if player.bot > 0 then break end -- player is bot, don't run

        if not player.mmenuinit then
            player.mmenuinit = true
            player.mmtusingmenu = false -- Is submenu open?
            player.mmenuitem = 1 -- Current menu option selected
            
            player.mmenutablechosen = "mmt_MainMenu"
            
            
            player.mmthud = {} -- misc. hud stuff goes here
            player.mmthud.TransBack = 10

            player.loadtimer = 0

                -- [[ Populate Options ]] --
            for n = 1, #mmt_MainMenu do -- For every entry in the menu
                if mmt_MainMenu[n].jumptostring then
                    local tabler = mmt_ListOTables[mmt_MainMenu[n].jumptostring]
                    if not tabler.textonly then
                        for index = 1, #tabler do
                            local entry = tabler[index]
                            if entry.prop then
                                if player[entry.prop] == nil then
                                    if entry.default then
                                        player[entry.prop] = entry.default
                                    else -- best hope you didn't forget to set a default for a string
                                        player[entry.prop] = entry.range[1] -- Set minimum value from range
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end

        local convertedMenu = mmt_ListOTables[player.mmenutablechosen]

        -- [[ Menu System ]] --
        if player.mmtusingmenu then
            -- transparency effect, fade in
            if (leveltime % 1 == 0) and player.mmthud.TransBack > 1 then
                player.mmthud.TransBack = $ - 1
            end

            if player.mmtbt.vmoving then -- Vertical movement check
                -- Menu pointer movement
                if player.mmtbt.up == 1 or ((player.mmtbt.up > TICRATE/3) and (player.mmtbt.up % 3 == 0)) then
                    player.mmenuitem = $-1
                    S_StartSound(nil, sfx_ding, player)
                end
                if player.mmtbt.down == 1 or ((player.mmtbt.down > TICRATE/3) and (player.mmtbt.down % 3 == 0)) then
                    player.mmenuitem = $+1
                    S_StartSound(nil, sfx_ding, player)
                end
            end
            
            -- loop around table if we've exceeded max limits

            local HiddenOptions = 0
            if convertedMenu then
                for index, value in ipairs(convertedMenu) do
                    if value.hide then
                        HiddenOptions = $ + 1
                    end
                end
            end

            local max = #convertedMenu - HiddenOptions

            if player.mmenuitem > max then
                player.mmenuitem = 1
            end
            if player.mmenuitem < 1 then
                player.mmenuitem = max
            end

            -- enter menu
            if player.mmtbt.jump == 1 then
                if convertedMenu[player.mmenuitem].jumptostring
                and not convertedMenu[player.mmenuitem].nonetgame or (convertedMenu[player.mmenuitem].nonetgame and not netgame)
                and not convertedMenu.colorsmenu -- manual override for some weirdness; it's jank and i should fix it properly, but that's for future me to deal with 
                then
                    player.mmenutablechosen = convertedMenu[player.mmenuitem].jumptostring
                    if not convertedMenu.submenu then
                        player.mmenurestoreselection = player.mmenuitem
                    end
                    player.mmenuitem = 1
                    S_StartSound(nil, sfx_menu1, player)
                elseif convertedMenu[player.mmenuitem].soundz then
                    local entry = convertedMenu[player.mmenuitem]
                    if entry then
                        local SFXPLAY = convertedMenu[player.mmenuitem].soundz[player[entry.prop]]
                        if SFXPLAY then -- lots of if statements here tbh
                            S_StartSound(nil, SFXPLAY, player)
                        end
                    end
                end
            end

            -- exit (to main) menu
            if player.mmtbt.spin == 1 then
                if convertedMenu.submenu then
                    player.mmenutablechosen = "mmt_MainMenu"
                    player.mmenuitem = 1
                    if player.mmenurestoreselection then -- just for in case
                        player.mmenuitem = player.mmenurestoreselection
                        player.mmenurestoreselection = nil
                    end
                    S_StartSound(nil, sfx_menu1, player)
                else -- exiting main menu
                    if not netgame then -- seems to cause issues
                        player.mmtusingmenu = false
                        MMT_SaveOptions(player)
                    end
                end
                if not netgame then -- seems to cause issues
                    player.mmenuWaitUntilLetGo = true
                end
            end
            
            -- in submenu, can change options now
            if convertedMenu.submenu
            and convertedMenu[player.mmenuitem] -- don't know why i need to check for this all of a sudden, it worked just fine in v5.0
            and convertedMenu[player.mmenuitem].prop
            and not convertedMenu.textonly then
                if player.mmtbt.hmoving or player.mmtbt.jump then -- Horizontal movement check
                    -- Value setting
                    local entry = convertedMenu[player.mmenuitem] -- Current menu entry
                    local val = player[entry.prop] -- Copy this for now
                    local multiplier = convertedMenu[player.mmenuitem].multiplier
                    if not entry.nonetgame or (entry.nonetgame and not netgame) then
                        if multiplier then
                            val = $ / multiplier
                        end

                        if entry.stringoptions then
                            for index, value in ipairs(entry.stringoptions) do
                                if value == player[entry.prop] then
                                    val = index
                                end
                            end
                        end
                        
                        -- increase/decrease option
                        if player.mmtbt.right == 1 or ((player.mmtbt.right > TICRATE/3) and (player.mmtbt.right % 3 == 0)) then
                            val = $+1
                            S_StartSound(nil, sfx_ding, player)
                        end
                        if player.mmtbt.left == 1 or ((player.mmtbt.left > TICRATE/3) and (player.mmtbt.left % 3 == 0)) then
                            val = $-1
                            S_StartSound(nil, sfx_ding, player)
                        end

                        if player.mmtbt.jump == 1 and convertedMenu.colorsmenu then
                            val = 0
                            if entry.name == "Character" then
                                val = -1
                                if player[entry.prop] == -1 then -- already set to off, set it to the skin you started with
                                    local GetNumber = 0
                                    local GotNumber = false
                                    for skin in skins.iterate() do -- this is super janky, but it's all because i'm not allowed to get the raw number for a skin. thanks stjr
                                        if not GotNumber then
                                            if skin.name != player.OriginalTheCharacter then
                                                GetNumber = $ + 1
                                            else
                                                GotNumber = true
                                                break
                                            end
                                        end
                                    end
                                    val = GetNumber
                                end
                            end
                            S_StartSound(nil, sfx_ding, player)
                        end

                        -- loop around table if we've exceeded max limits; and also apply the final val unit
                        if entry.stringoptions then
                            if val > #entry.stringoptions then
                                val = 1
                            end
                            if val < 1 then
                                val= #entry.stringoptions
                            end
                            val = entry.stringoptions[val]
                        else
                            if val > entry.range[2] then
                                val = entry.range[1]
                            end
                            if val < entry.range[1] then
                                val = entry.range[2]
                            end
                        end
                        
                        if multiplier then
                            val = $ * multiplier
                        end
                        player[entry.prop] = val
                        if convertedMenu.colorsmenu then
                            player.mmtcolorset = false
                            if entry.name == "Character" then
                                player.mmtcharacterset = false
                            end
                        end
                    end
                end
            end
        else
            -- fade transparency
            if (leveltime % 2 == 0) and player.mmthud.TransBack < 10 then
                player.mmthud.TransBack = $ + 1
            end
        end

        player.mmthud.TransFlags = player.mmthud.TransBack<<V_ALPHASHIFT -- trans rights!

        if player.mmtbt.spin == 0 then
            player.mmenuWaitUntilLetGo = false
        end
    end
end)


addHook("PlayerSpawn", function(player)
    player.loadtimer = 0
    player.MusicVolume = 100
    player.prevdrawangle = nil
    player.idlewait = 0
    player.GrantedContinue = false
    player.GotContinue = false
    player.scoretocalculate = 0
    if not player.OriginalTheCharacter then
        player.OriginalTheCharacter = player.mo.skin
    end
end)

local function GenerateHUDTable(player)
    local convertedMenu = mmt_ListOTables[player.mmenutablechosen]
    local Tabler = {}
    Tabler = {}
    Tabler.indexoffset = 0
    -- Title Text --
    local Injection -- get vaccinated today
    if convertedMenu.title then
        Injection = {}
        Tabler.indexoffset = $ + 1
        Injection.text = "\x87" .. convertedMenu.title
        Injection.align = "center"
        table.insert(Tabler, Injection)
    end

    if convertedMenu.subtitles then
        for index, value in ipairs(convertedMenu.subtitles) do
            Injection = {}
            Tabler.indexoffset = $ + 1
            Injection.text = "\x80" .. value
            Injection.font = "thin"
            Injection.align = "center"
            table.insert(Tabler, Injection)
        end
    end

    if convertedMenu.mainmenu then -- warning specifically for multiplayer
        if netgame then
            Injection = {}
            Tabler.indexoffset = $ + 1
            Injection.text = "\x82" .. "You MUST run the \"mmtmenu\" command again to exit in multiplayer!"
            Injection.font = "thin"
            Injection.align = "center"
            table.insert(Tabler, Injection)
        end
    end

    for i = 1,#convertedMenu do -- For every entry in the menu
        local entry = convertedMenu[i]
        -- Options --
        if convertedMenu[i].name and not convertedMenu[i].hidename and not convertedMenu[i].hide then
            Injection = {}
            if not entry.nonetgame or (entry.nonetgame and not netgame) then
                Injection.text = convertedMenu[i].name
            else
                Injection.text = "\x86" .. convertedMenu[i].name
            end
            Injection.align = "center"
            table.insert(Tabler, Injection)
        end

        if convertedMenu.submenu then -- in submenu, render options
            Injection = {}
            if entry.prop then
                Injection.text = player[entry.prop]
            elseif entry.setto then
                Injection.text = entry.setto
            end
            if convertedMenu[i].multiplier then
                Injection.text = $ / convertedMenu[i].multiplier
            end
            Injection.font = "thin"
            if convertedMenu.colorsmenu then
                local namer = player[entry.prop]
                if entry.name == "Color" then
                    if (player[entry.prop] > 0 and player[entry.prop] < #skincolors) and skincolors[player[entry.prop]] then
                        namer = skincolors[player[entry.prop]].name
                    elseif player[entry.prop] == 0 then
                        namer = "off"
                    end
                    Injection.text = namer
                elseif entry.name == "Character" then
                    if (player[entry.prop] > -1 and player[entry.prop] < #skins) and skins[player[entry.prop]] then
                        namer = skins[player[entry.prop]].realname
                    elseif player[entry.prop] == -1 then
                        namer = "off"
                    end
                    Injection.text = namer
                end
            end
            if entry.font then
                if entry.font == "normal" then
                    Injection.font = nil
                else
                    Injection.font = entry.font
                end
            end
            Injection.align = "center"
            Injection.option = true
            table.insert(Tabler, Injection)
        end
    end
    return Tabler
end

hud.add(function(v,player,c)
    if not player then return end

    local convertedMenu = mmt_ListOTables[player.mmenutablechosen]
    local TableTime = GenerateHUDTable(player)
    
	if player then -- menu system initialized
        v.drawScaled(0, 200 , FRACUNIT*200, v.cachePatch("THEYHAVEIT"), player.mmthud.TransFlags|V_SNAPTOLEFT|V_SNAPTOTOP) -- the dark background

        for i = 1,#convertedMenu do -- For every entry in the menu
            local entry = convertedMenu[i]

            
            if i == player.mmenuitem and entry.description then
                v.drawString(160, 190, "\x82" .. entry.description, player.mmthud.TransFlags|V_ALLOWLOWERCASE, "thin-center")
            end
        end

        --[[local ycalc = 0
        -- total y = 200
        for i = 1,#TableTime do -- first iteration, need to get yoffset
            local entry = TableTime[i]
            if entry.font then
                ycalc = $ + 6
            else
                ycalc = $ + 9
            end
        end
        -- should have total height now
        print(ycalc)]]

        local Optioneer = 0
        local totalyoffset = 0
        for i = 1,#TableTime do
            local entry = TableTime[i]
            local text  = entry.text
            local multiplier = 8
            local Font = entry.font

            if entry.option then
                Optioneer = $ + 1
            end

            if Font == "small" then
                multiplier = 6
            else
                multiplier = 10
            end

            totalyoffset = $ + multiplier

            local xoffset = 15
            local yoffset = -5

            if entry.align == "center" then
                xoffset = 160
            end

            -- apply font and/or align effects
            if entry.font then
                Font = entry.font
                if entry.align then
                    Font = $ + "-" .. entry.align
                end
            elseif entry.align then
                Font = entry.align
            end

            -- add cursor
            if convertedMenu.submenu then
                if entry.option and Optioneer == player.mmenuitem then
                    local Cursor1 = "\x81< \x83"
                    local Cursor2 = "\x81 >"
                    if convertedMenu.textonly then
                        Cursor1 = "\x81> \x83"
                        Cursor2 = "\x81 <"
                    end
                    text = Cursor1 + text .. Cursor2
                elseif entry.option then -- option that isn't selected, highlight in grey
                    text = "\x86" + text
                else -- presumed title of option, better hope i'm right
                    if not entry.nonetgame or (entry.nonetgame and not netgame) then
                        text = "\x84" + text
                    else
                        text = "\x86" + text
                    end
                end
            else
                if i-TableTime.indexoffset == player.mmenuitem then
                    local Cursor1 = "\x81> \x83"
                    local Cursor2 = "\x81 <"
    
                    text = Cursor1 + text .. Cursor2
                else
                    text = "\x86" + text
                end
            end

            v.drawString(xoffset, yoffset+(i*multiplier), text, player.mmthud.TransFlags|V_ALLOWLOWERCASE, Font)
        end

        if convertedMenu.colorsmenu then -- Draw player's character here
            if v.frame == nil then
                v.frame = 0
                v.rotatetimer = 0
                v.flipper = false
                v.idletimer = 0
            end
            v.frame = $ + 1
            --v.rotatetimer = $ + 1
            -- commented out because tails would look werid if he rotated lmao, he won't have his tails. if STJR gets around to rendering the tails in the multiplayer menu themselves, then i might.
            local delay = 5
            local Spriter = SPR2_WALK

            if not player.mmtbt.hmoving then
                v.idletimer = $+1
            else
                v.idletimer = 0
            end

            if player.mmtbt.hmoving > 2*TICRATE then
                delay = 2
                Spriter = SPR2_RUN
            end

            if v.idletimer > 4*TICRATE then
                delay = 15
                Spriter = SPR2_WAIT
            end
            
            local Framer = v.frame / delay
            local Rotater = 2 --v.rotatetimer / 12
            if player.followitem or
            player.mo.skin == "fluffy" then -- chrispy thinks he's too cool for follow items! well he's right
                Rotater = 1
            end

            if Rotater > 8 then
                v.flipper = not v.flipper
                v.rotatetimer = 0
                Rotater = 0
            end
            if skins[player.mo.skin].sprites[Spriter].numframes then
                if Framer > skins[player.mo.skin].sprites[Spriter].numframes-1 then
                    v.frame = 0
                    Framer = v.frame / delay
                end
            else
                v.frame = 0
                Framer = 0
            end

            local character, flipped = v.getSprite2Patch(player.mo.skin, Spriter, false, Framer, Rotater)
            local colormap = v.getColormap(player.mo.skin, player.mo.color)
            local flags = nil
            if flipped == true then
                flags = V_FLIP
            end

            v.drawScaled(160*FRACUNIT, (totalyoffset*FRACUNIT) + (70*FRACUNIT), FRACUNIT, character, flags, colormap)
        else
            v.idletimer = 0
        end
	end

    if player and (player.loadtimer >= (2*TICRATE + TICRATE/2) and not player.ReadHelp) then
        v.drawString(160, 155, "You are now using Many Minor Tweaks v" .. mmtversion .."!", V_ALLOWLOWERCASE|V_30TRANS, "thin-center")
        v.drawString(160, 165, "Please open the console (press\x87 ~\x80) and type\x87 mmtmenu\x80 to get started!", V_ALLOWLOWERCASE|V_30TRANS, "thin-center")
        v.drawString(160, 175, "P.S. The game \x85" .. "does not pause" .."\x80 while you're in the MMT menu!", V_ALLOWLOWERCASE|V_30TRANS, "thin-center")
    end
end, "game")


addHook("NetVars", function(net)
    mmt_MainMenu = net(mmt_MainMenu)
end)