--[[ Many Minor Tweaks v5.1
Author: birbhorse aka EeveeEuphoria/scorbuny
This is the third do-over of "Many Minor Tweaks", in which this should hopefully be the last one for a good long while. The last two versions were really not well-made, and although this one isn't a masterpiece or anything, this should be much easier to work with now.
Credits
    - TrustyGun for Spring Twirl (https://mb.srb2.org/addons/spring-twirl.1213/)
	- ffoxD for Spin Steer (https://mb.srb2.org/addons/ffoxds-lua-dumpster.1429/)
	- Kirb for "Air walk remover" (https://mb.srb2.org/addons/air-walk-remover-with-explanations-and-links.2815/)
	- Krabs and Stonecutter for Anglestand (https://mb.srb2.org/threads/anglestand-1-5-1-angleability.29160/)
	- TehRealSalt for Jump Leniency (https://mb.srb2.org/addons/jump-leniency.2821/)
	- Lianvee for Personal Sounds (https://mb.srb2.org/addons/personal-sounds.2924/)
	- amperbee for PBT3 and helping with a functioning menu system
     __     __            __     __       ________
    /  \   /  \          /  \   /  \     |___  ___|
   /    \_/    \        /    \_/    \       |  |
  /  /\     /\  \      /  /\     /\  \      |  |
 /  /  \   /  \  \    /  /  \   /  \  \     |  |
/__/    \_/    \__\  /__/    \_/    \__\    |__|
                               _____
                ___     ___   |   __|
                 \  \_/  /    |  |__
                  \     /     |__   |
                   \   /       __|  |
                    \_/       |_____|
]]

freeslot("S_PLAY_ANGLEIDLE", "MT_FAKE_SHIELD", "MT_FAKE_SHIELD2")
states[S_PLAY_ANGLEIDLE] = {SPR_PLAY, SPR2_WAIT, 16, nil, 0, 0, S_PLAY_ANGLEIDLE}

mobjinfo[MT_FAKE_SHIELD] = {
	doomednum = -1,
	spawnstate = S_WIND1,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = SH_WHIRLWIND,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 4,
	mass = 16,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_FAKE_SHIELD2] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = SH_WHIRLWIND,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 4,
	mass = 16,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

local MMTclassicshields = "off"

-- [[[ General Functions ]]] --


local function P_SpawnCoolSkidDust(player, radius, sound)
    local particle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
    local xn = P_RandomChance(FRACUNIT/2)
    local yn = P_RandomChance(FRACUNIT/2)
    if xn then xn = -1 else xn = 1 end
    if yn then yn = -1 else yn = 1 end

    local x = particle.x + (xn * (FixedMul(radius,P_RandomFixed()) << FRACBITS))
    local y = particle.y + (yn * (FixedMul(radius,P_RandomFixed()) << FRACBITS))
    local z = particle.z --+ (P_RandomRange(0, FRACUNIT-1))
    P_TeleportMove(particle, x, y, z)
    particle.tics = 10
    particle.scale = (2*player.mo.scale)/3
    particle.momx = player.mo.momx/4
    particle.momy = player.mo.momy/4
    P_SetScale(particle, particle.destscale)
    P_SetObjectMomZ(particle, FRACUNIT, false)
    if player.powers[pw_super] then
        P_SetObjectMomZ(particle, FRACUNIT*3, false)
    end

    if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) then -- smoke looks weird underwater
        particle.state = S_SPLISH1
    end

    if sound then
        S_StartSound(player.mo, sfx_s3k7e)
    end
    return particle -- the one thing the original version of this didn't do, smh smh
end

local function SuperTransition(player) -- trans rights
    if ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2) or (player.mo.state == S_PLAY_SUPER_TRANS3) or (player.mo.state == S_PLAY_SUPER_TRANS4) or (player.mo.state == S_PLAY_SUPER_TRANS5) or (player.mo.state == S_PLAY_SUPER_TRANS6))
        return true
    else
        return false
    end
end

local function BasicSuperCheck(player)
    if not P_IsObjectOnGround(player.mo) and player.rings >= 50 and All7Emeralds(emeralds) and not player.powers[pw_super] and (player.playerstate == PST_LIVE) -- basic checks
    and (player.super4all == "on" or (skins[player.mo.skin].flags & SF_SUPER)) -- check to see if player is allowed to be super
    and player.mmtbt.spin < 2 -- make sure player isn't holding spin when jumping; not completely fool proof but it does the job
    and not (player.pflags & PF_THOKKED) and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not (player.pflags & PF_SHIELDABILITY) and (player.pflags & PF_JUMPED) and not SuperTransition(player) -- misc. checks
    and not SuperTransition(player)
    and ((player.powers[pw_shield] == 0) or (player.powers[pw_shield] > 0 and player.superkey != "spin")) -- ensure player doesn't have shield, or can use it w/ different key
    then
        return true
    else
        return false
    end
end

local function GiveSuper(player)
    player.pflags = $ & ~PF_JUMPED
    player.charflags = $1 | SF_SUPER
    if player.supermusic == "off" then
        P_DoSuperTransformation(player, false)
    else
        player.powers[pw_super] = 1
        player.mo.state = S_PLAY_SUPER_TRANS1
        S_StartSound(player.mo, sfx_supert, player)
    end
end

addHook("ThinkFrame", function()
    for player in players.iterate do
        --local player = mo.player
        if not (player and player.valid) then break end -- player does not exist, don't run
        --if not (player == consoleplayer) then break end -- playing player is not player, don't run
        if not (player.realmo and player.realmo.valid) then break end -- player does not exist 2: revengence, don't run
        if player.bot > 0 then break end -- player is bot, don't run

        if not player.mmenuinit then break end

        -- [[ Load in settings ]] --
        player.loadtimer = $ + 1

        local waittime = TICRATE/5
        if netgame then -- want to really be sure players can load in their settings
            waittime = TICRATE + TICRATE/2
        end

        if player.loadtimer > waittime then
            if not player.MMTloaded then
                COM_BufInsertText(player, "exec mmtconf.cfg -noerror")
                player.MMTloaded = true
            end
        end

        -- [[ Classic Shields, very janky but i don't really care to make this proper ]] --

        if not netgame then
            MMTclassicshields = player.classicshields
        end

        -- [[ Controls ]] --

        -- Recurl --
        if (player.recurl != "off" and (player.charability2 == CA2_SPINDASH)) then
            if player.mo.sprite2 == SPR2_SPNG then
                player.UsedSpring = true
            elseif (player.panim == PA_PAIN and not P_PlayerInPain(player)) then
                player.UsedTornado = true
            elseif not player.UsedSpring and not player.UsedTornado and player.panim == PA_FALL and not (player.pflags & PF_SHIELDABILITY) and not (player.charability == CA_FLOAT and (player.pflags & PF_THOKKED)) then
                player.UsedMisc = true
            end

            if player.recurl == "spin" then
                player.MMTrecurlKey = BT_USE
            else
                player.MMTrecurlKey = BT_JUMP
            end


            if not P_IsObjectOnGround(player.mo)
            and ((player.UsedSpring or player.UsedMisc) or (player.UsedTornado and (player.panim == PA_FALL)))
            and (player.cmd.buttons & player.MMTrecurlKey)
            and (player.charability2 == CA2_SPINDASH)
            and player.secondjump == 0 -- prevents weirdness with super sonic
            --and (not player.recurlwait or (player.UsedSpring and player.UsedTornado and player.panim == PA_FALL))
            and player.mo.state != S_PLAY_JUMP then
                player.mo.state = S_PLAY_JUMP
                player.pflags = $1 | PF_JUMPED
                player.pflags = $1 | PF_THOKKED
                S_StartSound(player.mo, sfx_spin, player)
                --if player.MMTrecurlmulti != "on" then player.recurlwait = true end
            end

            if P_IsObjectOnGround(player.mo) then
                player.UsedSpring = false
                player.UsedTornado = false
                player.UsedMisc = false
            end
        end

        -- Uncurl --
        if player.uncurl == "on" then
            if player.denyuncurl and player.mmtbt.spin == 0 then
                player.denyuncurl = false
            end
            -- the function that sets this true is located in the PreThinkFrame hook found in lua_options

            if P_IsObjectOnGround(player.mo)
            and (player.pflags & PF_SPINNING)
            and not player.denyuncurl
            and (player.speed > player.runspeed - player.runspeed/3)
            and player.mmtbt.spin == 1
            then
                player.pflags = $ & ~PF_SPINNING
                player.mo.state = S_PLAY_WALK
                S_StartSound(player.mo,sfx_3db16)
            end

        end

        -- Spin Control --
        if player.spinsteer > 0 then
            if (player.pflags & PF_SPINNING) and not (player.pflags & PF_STARTDASH) and not (player.pflags & PF_JUMPED) and (player.panim == PA_ROLL)
            and (P_IsObjectOnGround(player.mo) or player.spstmidair != "off") then
                if not player.StoredThing then
                    player.StoredThing = player.thrustfactor
                end
                local Value = player.spinsteer
                if not P_IsObjectOnGround(player.mo) and player.spstmidair != "normal" then
                    if player.spstmidair == "lightest" then
                        Value = $/2
                    else
                        Value = $/2 + Value/3
                    end
                end
                player.thrustfactor = (skins[player.mo.skin].thrustfactor)*Value
            elseif player.StoredThing then
                player.thrustfactor = player.StoredThing
                player.StoredThing = nil
            end
        end

        -- Tails Drop Ball --
        if player.tailsball != "off" then
            if ((player.charability == CA_FLY) and (player.charability2 == CA2_SPINDASH) and (skins[player.mo.skin].name != "eggman"))
            and player.panim == PA_ABILITY and (player.cmd.buttons & mmt_ConvertStringKey(player.tailsball)) then
                S_StartSound(player.mo,sfx_3db16)
                player.mo.state = S_PLAY_JUMP
                player.pflags = $1 | PF_JUMPED
                player.pflags = $1 | PF_THOKKED
                player.pflags = $ & ~PF_CANCARRY
            end
        end

        -- Tails Hold Fly --
        if player.holdfly != "off" then
            if (player.powers[pw_tailsfly] > 0) and player.mmtbt.jump > 0 then
                player.fly1 = 1
            end
        end

        -- Speedier Spin --
        if player.speedierspin == "on" then
            if player.powers[pw_sneakers] or player.powers[pw_super] then
                player.speedierspininuse = true
                player.speedierspinrestore = false
                player.maxdash = skins[player.mo.skin].maxdash / 2
                if player.mmtbt.spin == 0 and (player.pflags & PF_STARTDASH) then
                    player.dashspeed = $ * 2
                end
            else
                player.speedierspininuse = false
            end
        else
            player.speedierspininuse = false
        end

        if not player.speedierspininuse and not player.speedierspinrestore then
            player.maxdash = skins[player.mo.skin].maxdash
            player.speedierspinrestore = true
        end

        -- [[ Enhancements ]] --
    
        -- Preserve Shield --
        if player.preserveshield == "on" then
            -- ((player.pflags & PF_FINISHED) or stoppedclock)
            if G_EnoughPlayersFinished() then
                if not player.ShieldAlreadySaved and not G_IsSpecialStage(gamemap) then
                    player.ShieldAfterLevel = player.powers[pw_shield]
                    player.ShieldAlreadySaved = true
                    player.ShieldLevelName = mapheaderinfo[gamemap].lvlttl
                    mmtdebuggerPrint(player, "Saving shield! Shield saved is: " .. player.ShieldAfterLevel)
                end
            elseif player.ShieldAlreadySaved and player.preserveshield == "on" and not G_IsSpecialStage(gamemap) then
                if (player.ShieldLevelName == mapheaderinfo[gamemap].lvlttl) or player.preserveshieldzones == "on" then
                    player.powers[pw_shield] = player.ShieldAfterLevel
                    mmtdebuggerPrint(player, "Shield spawned is: " .. player.ShieldAfterLevel)
                    P_SpawnShieldOrb(player)
                end
                player.ShieldAlreadySaved = false
            end
        end

        -- Water Running --

        if player.waterrunner == "on" and not (skins[player.mo.skin].flags & SF_RUNONWATER) then
            if abs(player.mo.momz) < FRACUNIT and (player.speed >= player.runspeed + player.rowreq) then
               player.charflags = $1|SF_RUNONWATER
            else
               player.charflags = $1 & ~SF_RUNONWATER
            end
        end

        -- Fade Music --
        if player.MMTfademusic == "on" then
            if G_EnoughPlayersFinished() then
                if player.MusicVolume > 0 then
                    player.MusicVolume = $ - 1
                end
            --[[elseif player.mmtusingmenu then
                if player.MusicVolume > 66 then
                    player.MusicVolume = $ - 1
                end]]
            else
                if player.MusicVolume < 101 then
                    player.MusicVolume = $ + 1
                end
            end
        else
            if player.MusicVolume < 101 then
                player.MusicVolume = $ + 1
            end
        end
        if player.MusicVolume < 101 then
            S_SetInternalMusicVolume(player.MusicVolume, player)
        end

        -- Speedy Particles --
        if player.speedyparts == "on" then
            if P_IsObjectOnGround(player.mo) and (player.speed > player.runspeed) then
                local part = P_SpawnCoolSkidDust(player, 16, false)
                part.destscale = player.mo.scale/6+player.mo.scale/5
                part.scalespeed = FRACUNIT/19
            end
        end
        --FixedMul(player.runspeed, 2*FRACUNIT+FixedDiv(3*FRACUNIT, 4*FRACUNIT))
        if player.speedyflames == "on" then
            if P_IsObjectOnGround(player.mo) and not (player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)) and 
            (player.speed > 55*FRACUNIT or (player.speed > 40*FRACUNIT and (player.powers[pw_sneakers] or player.dashmode >= 3*TICRATE))) then
                local part2 = P_SpawnCoolSkidDust(player, 12, false)
                part2.state = S_SPINDUST_FIRE1
                part2.destscale = player.mo.scale/2+player.mo.scale/11
                part2.scalespeed = FRACUNIT/30
                part2.tics = TICRATE
            end
        end

        -- Ring Scattering --

        if player.ringscatter == "on" then
            player.losstime = 0
        end

        -- [[ Super Form Options ]] --

        -- Option 1: Super Button --
        if not G_EnoughPlayersFinished() then
            if player.superkey != "off" then
                if not player.powers[pw_super] then player.charflags = $ & ~SF_SUPER end
                if (player.cmd.buttons & mmt_ConvertStringKey(player.superkey)) and BasicSuperCheck(player) then
                    GiveSuper(player)
                end
                -- super sector
                if P_PlayerTouchingSectorSpecial(player, 4, 6) and All7Emeralds(emeralds) and not player.powers[pw_super] then
                    player.rings = 50
                    GiveSuper(player)
                end
            end
        end
        -- Option 2: Super Cancel --
        if player.cancelsuperkey != "off" and player.powers[pw_super] then
            if (player.cmd.buttons & mmt_ConvertStringKey(player.cancelsuperkey)) and not SuperTransition(player) then
                player.pflags = $1 | PF_THOKKED
                player.powers[pw_flashing] = TICRATE
                player.powers[pw_super] = 0
                player.mo.color = player.skincolor
                P_RestoreMusic(player)
                P_SpawnShieldOrb(player)
            end
        end
        
        -- Option 3: Super Forms for All --
        if player.superkey == "off" then
            if player.super4all == "on" then
                player.charflags = $1 | SF_SUPER
            elseif not (skins[player.mo.skin].flags & SF_SUPER) then
                player.charflags = $ & ~SF_SUPER
            end
        end

        -- Option 5: Super Trail --
        if player.supertrails == "on"
        and player.powers[pw_super] and not player.mo.hyperflashcolor -- prevents conflict with hyper abilities
        and not (player.speed < 4*FRACUNIT and player.mo.momz == 0) then
            local traily = P_SpawnGhostMobj(player.mo)
            traily.fuse = 4
            traily.rollangle = player.mo.rollangle
            if (traily.tracer) then
                traily.tracer.fuse = 4
            end
        end

        -- [[ Character Menu stuff ]] --
        if not netgame then
            -- Character --
            if player.mmtplayerskin > -1 then
                if not player.mmtcharacterset then
                    R_SetPlayerSkin(player, skins[player.mmtplayerskin].name)
                    player.mmtcharacterset = true
                end
            end
            -- Skin Color --
            if player.mmtplayercolor > 0 then
                if player.skincolor != player.mmtplayercolor then
                    player.mmtcolorset = false
                end
                if not player.mmtcolorset then
                    player.skincolor = player.mmtplayercolor
                    player.mo.color = player.skincolor
                    player.mmtcolorset = true
                end
                player.mmtcolorreset = false
            elseif not player.mmtcolorreset then
                player.skincolor = skins[player.mo.skin].prefcolor
                player.mo.color = player.skincolor
                player.mmtcolorreset = true
            end
        end

        -- [[ Misc. Options ]] --

        -- Instant Respawn --
        if player.instantrespawn == "on" then
            if (gametype == GT_COOP) and player.playerstate == PST_DEAD then
                player.playerstate = PST_REBORN
            end
        end

        -- No More Air Walking --
        if player.noairwalk == "on" and
        ((player.CoyoteTime == "on" and player.mo.coyoteTime == 0) or (player.CoyoteTime == "off")) -- just something to make things seem smoother
        then
            player.FallingAnimation = true
            if not(P_IsObjectOnGround(player.mo))
            and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
            and not player.powers[pw_carry] then
                player.mo.state = S_PLAY_FALL
            end
        else
            player.FallingAnimation = false
        end

        -- Super Shield --
        if player.MMTsupershield == "on" and player.bot != 1 then
            if not player.FakeShield and player.playerstate == PST_LIVE then
                player.FakeShield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_FAKE_SHIELD)
                player.FakeShield.target = player.mo
            end
            if player.FakeShield and player.FakeShield.valid then
                local shield = player.FakeShield
                if (player.powers[pw_super] or player.powers[pw_invulnerability]) and shield.DontRender then
                    mmtdebuggerPrint("player is super, re-enabling render")
                    shield.DontRender = false
                    shield.SetState = false
                end
            end
            
            if player.playerstate == PST_DEAD and player.FakeShield and player.FakeShield.valid then
                player.FakeShield.TerminateSelf = true
                player.FakeShield = nil
            end
        end

        if player.MMTsupershield == "off" then
            if player.FakeShield then
                player.FakeShield.TerminateSelf = true
                player.FakeShield = nil
            end
        end

        -- Score-Based Continues --
        if G_IsSpecialStage(gamemap) then -- very specific and janky workaround
            player.ContinueHudDontRender = true
        end

        player.skincont = player.mo.skin -- have to do this because intermission hud can't access mobj data, thanks stjr >:(
        player.colorcont = player.mo.color -- have to do this because intermission hud can't access mobj data, thanks stjr >:(

        if (player.pflags & PF_FINISHED) and not G_IsSpecialStage(gamemap) and player.scorecontinues == "on" then
            player.scoretocalculate = player.score
            --mmtdebuggerPrint("gamer")
        end

        -- Menu Music --
        if player.menumusic == "on" then
            if player.mmtusingmenu and not player.MusicSet then
                player.MusicSet = true
                S_ChangeMusic("MMTM", true, player)
            end
            if not player.mmtusingmenu and player.MusicSet then
                player.MusicSet = false
                P_RestoreMusic(player)
            end
        else
            if player.MusicSet then
                player.MusicSet = false
                P_RestoreMusic(player)
            end
        end
    end
    if netgame then MMTclassicshields = "off" end
end)

-- [[ SFX Style ]] --
-- Code is somewhat derived from the "Personal Sounds" mod.

local JumpTable = {
    ["Sonic 1"] = sfx_s1a0,
    ["Sonic 2"] = sfx_s220,
    ["Sonic CD"] = sfx_cdfm02,
    ["Sonic 3K"] = sfx_s3k62,
    ["Knuckles' Chaotix"] = sfx_cdfm02,
    ["NiGHTS"] = sfx_ngjump,
    ["Super Mario Bros."] = sfx_mario6,
}

local SkiddingTable = {
    ["Sonic 1"] = sfx_s1a4,
    ["Sonic 2"] = sfx_s224,
    ["Sonic 3K"] = sfx_s3k36,
    ["Sonic CD"] = sfx_cdfm00,
    ["Knuckles' Chaotix"] = sfx_kc2b,
}

local PutPutTable = {
    ["Sonic 3K"] = sfx_s3kba,
}
local PudPudTable = {
    ["Sonic 3K"] = sfx_s3kbb,
}

local SpikesTable = {
    ["Sonic 1"] = sfx_s1a6,
    ["Sonic 2"] = sfx_s226,
    ["Sonic 3K"] = sfx_s3k37,
}

local DeathTable = { -- ominous name
    ["Sonic 1"] = sfx_s1a3,
    ["Sonic 2"] = sfx_s223,
    ["Sonic CD"] = sfx_cdfm03,
    ["Sonic 3K"] = sfx_s3k35,
    ["Knuckles' Chaotix"] = sfx_kc58,
}

local SpinningTable = {
    ["Sonic 1"] = sfx_s1be,
    ["Sonic 2"] = sfx_s23e,
    ["Sonic CD"] = sfx_cdfm12,
    ["Sonic 3K"] = sfx_s3k3c,
    ["Knuckles' Chaotix"] = sfx_cdfm12,
}

local SpindashTable = {
    ["Sonic 2"] = sfx_s260,
    ["Sonic CD"] = sfx_cdfm11,
    ["Sonic 3K"] = sfx_s3kab,
    ["Knuckles' Chaotix"] = sfx_kc6c,
}

local SpinzoomTable = {
    ["Sonic 2"] = sfx_s23c,
    ["Sonic CD"] = sfx_cdfm01,
    ["Sonic 3K"] = sfx_s3kb6,
    ["Knuckles' Chaotix"] = sfx_kc3c,
}

local GaspTable = {
    ["Sonic 1"] = sfx_s1ad,
    ["Sonic 2"] = sfx_s22d,
    ["Sonic CD"] = sfx_cdfm29,
    ["Sonic 3K"] = sfx_s3k38,
}

local DrownTable = {
    ["Sonic 1"] = sfx_s1b2,
    ["Sonic 2"] = sfx_s232,
    ["Sonic CD"] = sfx_cdfm38,
    ["Sonic 3K"] = sfx_s3k3b,
}

local AirTimerTable = { -- not possible because S_StopSoundByNum isn't exposed to lua. if i knew how to code C i swear to god i'd expose all these things for lua >:( this is also why i can't replace the 1-up sound too
    ["Sonic CD"] = sfx_cdfm49,
}

local SpringTable = {
    ["Sonic 1"] = sfx_s1cc,
    ["Sonic 2"] = sfx_s1cc,
    ["Sonic 3K"] = sfx_s3kb1,
    ["Sonic CD"] = sfx_cdfm08,
    ["Knuckles' Chaotix"] = sfx_kc2f
}


local function ReplaceSound(mo, value, table, sound)
    local obj = mo
    if mo.player then
        obj = mo.player.realmo
    end
    if value != "off"
    and S_SoundPlaying(obj, sound)
    and table[value] then
        S_StopSoundByID(obj, sound)
        S_StartSound(obj, table[value])
    end
end

local function ReplaceSoundsFunctionTime(player)
    if not (player and player.valid) then return end -- Player must exist.
    if not (player == consoleplayer) then return end -- We only worry about ourselves!
    if not (player.realmo and player.realmo.valid) then return end -- Their object ALSO must exist.

    local JumpVal = player.mmtsfxjump
    local SkiddingVal = player.mmtsfxskidding
    local TailsFlyVal = player.mmtsfxflight
    local DedVal = player.mmtsfxded
    local SpikesVal = player.mmtsfxspikes

    local SpinningVal = player.mmtsfxspinning
    local SpindashVal = player.mmtsfxspindash
    local SpinzoomVal = player.mmtsfxspinzoom
    local DrowningVal = player.mmtsfxdrowning
    local GaspVal = player.mmtsfxgasp

    if player.mmtsfxset != "off" then
        JumpVal = player.mmtsfxset
        SkiddingVal = player.mmtsfxset
        TailsFlyVal = player.mmtsfxset
        DedVal = player.mmtsfxset
        SpikesVal = player.mmtsfxset

        SpinningVal = player.mmtsfxset
        SpindashVal = player.mmtsfxset
        SpinzoomVal = player.mmtsfxset
        GaspVal = player.mmtsfxset
        DrowningVal = player.mmtsfxset
    end

    ReplaceSound(player.mo, JumpVal, JumpTable, sfx_jump)
    ReplaceSound(player.mo, SkiddingVal, SkiddingTable, sfx_skid)
    ReplaceSound(player.mo, TailsFlyVal, PutPutTable, sfx_putput)
    ReplaceSound(player.mo, TailsFlyVal, PudPudTable, sfx_pudpud)
    ReplaceSound(player.mo, SpikesVal, SpikesTable, sfx_spkdth)

    ReplaceSound(player.mo, SpinningVal, SpinningTable, sfx_spin)
    ReplaceSound(player.mo, SpindashVal, SpindashTable, sfx_spndsh)
    ReplaceSound(player.mo, SpinzoomVal, SpinzoomTable, sfx_zoom)
    ReplaceSound(player.mo, GaspVal, GaspTable, sfx_gasp)
    ReplaceSound(player.mo, DrowningVal, DrownTable, sfx_drown)


    if DedVal != "off" -- manually doing it for death because it's janky
    and (S_SoundPlaying(player.realmo, sfx_altdi1) or S_SoundPlaying(player.realmo, sfx_altdi2) or S_SoundPlaying(player.realmo, sfx_altdi3) or S_SoundPlaying(player.realmo, sfx_altdi4))
    and DeathTable[DedVal] then
        S_StopSoundByID(player.realmo, sfx_altdi1)
        S_StopSoundByID(player.realmo, sfx_altdi2)
        S_StopSoundByID(player.realmo, sfx_altdi3)
        S_StopSoundByID(player.realmo, sfx_altdi4)
        S_StartSound(player.realmo, DeathTable[DedVal])
    end
end

-- this is set up like this for in case i need to switch back to a playerthink function
-- if you're seeing this then i forgot to remove this text, and i didn't swap to a playerthink function
-- using postthinkframe is slightly better at cutting off sounds than the playerthink function, but might come at the cost of incompatibility with netgames, only time will tell

addHook("PostThinkFrame", function()
    for player in players.iterate do
        ReplaceSoundsFunctionTime(player)
    end
end)

--[[addHook("PlayerThink", function(player)
    if netgame then
        ReplaceSoundsFunctionTime(player)
    end
end)]]

-- [[ Token to Rings ]] --
addHook("TouchSpecial", function(emeraldtoken, toucher)
	if toucher.type == MT_PLAYER then
		local player = toucher.player
		if not emeraldtoken.CollectedTime and player.TokenToRings == "on" and All7Emeralds(emeralds) then
			P_GivePlayerRings(player, 50)
			P_AddPlayerScore(player, 1000)
			S_StartSound(player.mo, sfx_cdfm66)
			emeraldtoken.CollectedTime = true
			P_KillMobj(emeraldtoken)
			return true
		else
			return false
		end
	end
end, MT_TOKEN)

-- [[ Disable Super Hover ]] --
addHook("JumpSpinSpecial", function(player)
	if player.powers[pw_super] and player.charability == CA_THOK and player.disablesuperhover == "on" then
		return true
	end
end)

-- [[ Spring Twirl ]] --
-- pretty much ported wholesale from the original lua file
local function spring_twirl(mo)
	--assign player to a variable to make our lives a little bit easier (and our code a little bit readable)
	local player = mo.player
    if player.SpringTwirlOption == "off" then return end
	--is player.twirl_angle assigned? if not, create it.
	if player.twirl_angle == nil then
		player.spring_twirl = false
		player.twirl_angle = 0	--starts at 0
	end
	--clear the spring twirl flag when we are at 0 momz
	if mo.momz == 0 and player.spring_twirl == true then
		player.spring_twirl = false
		player.steam = false
	end
	--are we currently in the spring animation?
	if (player.panim == PA_SPRING or player.steam) and player.spring_twirl == true then
		--add to our twirl angle
		player.twirl_angle = player.twirl_angle + FixedAngle(mo.momz)
		--make our draw angle twirl angle, therefore showing us spinning when we hit a spring
		player.drawangle = player.twirl_angle
	end
end

local function vertical_spring(thing, toucher)
	--is our toucher a player?
	if toucher.type == MT_PLAYER then
        if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
            --height checks
            if toucher.player.SpringTwirlOption == "on" then
                --set spring twirl to true
                toucher.player.spring_twirl = true
                toucher.player.twirl_angle = toucher.angle
            end
            if states[thing.state].frame == 0 and ((toucher.player.mmtsfxspring != "off") or (toucher.player.mmtsfxset != "off")) then
                local sounder = toucher.player.mmtsfxspring
                if toucher.player.mmtsfxset != "off" then
                    sounder = toucher.player.mmtsfxset
                end
                if SpringTable[sounder] and sounder != "off" then -- just for in case something went really screwy
                    S_StartSound(toucher.player.realmo, SpringTable[sounder])
                    thing.stopsound = 1
                end
            end
        end
	end
end

local function stopsoundthing(spring)
    if spring.stopsound == nil then
        spring.stopsound = 0
    end
    if spring.stopsound > 0 then
        S_StopSoundByID(spring, sfx_spring)
        spring.stopsound = $ + 1
        if spring.stopsound > 8 then
            spring.stopsound = 0
        end
    end
end

local function diagonal_spring(thing, toucher)
	if toucher.type == MT_PLAYER then
        if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
            --height checks
            if toucher.player.SpringTwirlOption == "on" then
                --set spring twirl to false
                --this is only so that if we go from a vertical spring to a diagonal one, we don't twirl again
                --we don't have to do this for the horziontal springs since they don't put you into your spring animation
                toucher.player.spring_twirl = false
            end
            if states[thing.state].frame == 0 and ((toucher.player.mmtsfxspring != "off") or (toucher.player.mmtsfxset != "off")) then
                local sounder = toucher.player.mmtsfxspring
                if toucher.player.mmtsfxset != "off" then
                    sounder = toucher.player.mmtsfxset
                end
                if SpringTable[sounder] and sounder != "off" then -- just for in case something went really screwy
                    S_StartSound(toucher.player.realmo, SpringTable[sounder])
                    thing.stopsound = 1
                end
            end
        end
	end
end

local function horziontal_spring(thing, toucher)
    if toucher.type == MT_PLAYER then
        if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
            if states[thing.state].frame == 0 and ((toucher.player.mmtsfxspring != "off") or (toucher.player.mmtsfxset != "off")) then
                local sounder = toucher.player.mmtsfxspring
                if toucher.player.mmtsfxset != "off" then
                    sounder = toucher.player.mmtsfxset
                end
                if SpringTable[sounder] and sounder != "off" then -- just for in case something went really screwy
                    S_StartSound(toucher.player.realmo, SpringTable[sounder])
                    thing.stopsound = 1
                end
            end
        end
    end
end

addHook("MobjThinker", spring_twirl, MT_PLAYER)

addHook("MobjCollide", vertical_spring, MT_REDSPRING)
addHook("MobjCollide", vertical_spring, MT_YELLOWSPRING)
addHook("MobjCollide", vertical_spring, MT_BLUESPRING)
addHook("MobjCollide", vertical_spring, MT_SPRINGSHELL)
addHook("MobjCollide", vertical_spring, MT_YELLOWSHELL)
addHook("MobjCollide", vertical_spring, MT_YELLOWSPRINGBALL)
addHook("MobjCollide", vertical_spring, MT_REDSPRINGBALL)

addHook("MobjCollide", diagonal_spring, MT_REDDIAG)
addHook("MobjCollide", diagonal_spring, MT_YELLOWDIAG)
addHook("MobjCollide", diagonal_spring, MT_BLUEDIAG)

addHook("MobjCollide", horziontal_spring, MT_REDHORIZ)
addHook("MobjCollide", horziontal_spring, MT_YELLOWHORIZ)
addHook("MobjCollide", horziontal_spring, MT_BLUEHORIZ)


addHook("MobjThinker", stopsoundthing, MT_REDSPRING)
addHook("MobjThinker", stopsoundthing, MT_YELLOWSPRING)
addHook("MobjThinker", stopsoundthing, MT_BLUESPRING)
addHook("MobjThinker", stopsoundthing, MT_SPRINGSHELL)
addHook("MobjThinker", stopsoundthing, MT_YELLOWSHELL)
addHook("MobjThinker", stopsoundthing, MT_YELLOWSPRINGBALL)
addHook("MobjThinker", stopsoundthing, MT_REDSPRINGBALL)
addHook("MobjThinker", stopsoundthing, MT_REDDIAG)
addHook("MobjThinker", stopsoundthing, MT_YELLOWDIAG)
addHook("MobjThinker", stopsoundthing, MT_BLUEDIAG)
addHook("MobjThinker", stopsoundthing, MT_REDHORIZ)
addHook("MobjThinker", stopsoundthing, MT_YELLOWHORIZ)
addHook("MobjThinker", stopsoundthing, MT_BLUEHORIZ)


addHook("MobjCollide", function(thing, tmthing) -- adding in the spring twirl for steam, because i said so bitch
	if tmthing and tmthing.player then
		local player = tmthing.player
		if player.SpringTwirlOption == "on" then
            if thing.state == S_STEAM1 and abs(tmthing.z-thing.z) <= thing.height then
                player.spring_twirl = true
                player.twirl_angle = tmthing.angle
                player.steam = true -- turns out this is unnessecary now, but i'm leaving it in
                player.mo.state = S_PLAY_SPRING
                return true -- this causes this to run multiple times, but that's okay, it forces the player into the spring state and not much else
            end
        end
	end
end, MT_STEAM, MT_PLAYER)


-- [[ Commands ]] --

COM_AddCommand("mmtmenu", function(player, arg1)
	if not (player and player.valid) then return end
	if not (player.realmo and player.realmo.valid) then return end
	if G_EnoughPlayersFinished() then return end
	if player.playerstate == PST_DEAD then return end

	player.mmtusingmenu = not $
    if not player.mmtusingmenu then
        MMT_SaveOptions(player)
    end
	player.ReadHelp = true
end)

--sample: mmtload "Recurl" "off"

COM_AddCommand("mmtload", function(player, arg1, arg2, arg3)
	if not (player and player.valid) then return end
	if not (player.realmo and player.realmo.valid) then return end
    if tonumber(arg2) != nil then
        arg2 = tonumber(arg2)
    end

	if not arg1 then
		CONS_Printf(player, "NOTICE! This is not intended to be used by the player.")
		CONS_Printf(player, "This is meant for the save/load functionality.")
		return
	end

	-- player.mmtoptions[player.mmthud.ChangingOption].set[i]

	if arg1 == "MMTLOADCOMPLETE!!!" then
        if player.fullyloaded then return end
		CONS_Printf(player, "[\x89" .. "MMT" .. "\x80]\x8C Settings loaded" .. "\x80!")
		if player.ErrorLoading then
			CONS_Printf(player, "[\x89" .. "MMT" .. "\x80]\x82 Some of your previous settings could not be loaded properly" .. "\x80.")
			S_StartSound(nil, sfx_notadd, player)
		else
			S_StartSound(nil, sfx_addfil, player)
		end
        player.fullyloaded = true
		player.ReadHelp = true
		return
	end

    local Leg = false
    local Name = arg1
    for n = 1, #mmt_MainMenu do -- For every entry in the menu
        if mmt_MainMenu[n].jumptostring then
            local tabler = mmt_ListOTables[mmt_MainMenu[n].jumptostring]
            local Success = false
            if not tabler.textonly then -- not needed, just a bit of optimization really
                for index = 1, #tabler do -- every option menu found inside main menu
                    local entry = tabler[index]
                    if (entry.name == arg1 or entry.prop == arg3) then -- argument equals name, proceed onward
                        local SafeToGo = false
                        if entry.stringoptions then
                            for index2, value in ipairs(entry.stringoptions) do
                                if value == arg2 then
                                    SafeToGo = true
                                end
                            end
                        elseif entry.range then -- presumed number, clamp up or down or all around
                            if type(arg2) != "number" then
                                Success = false
                                break
                            end
                            if not entry.nosave then -- prevents an option that shouldn't have been saved from loading
                                player[entry.prop] = max(entry.range[1], min(entry.range[2], arg2))
                                SafeToGo = false
                                Success = true
                            end
                        end
                        
                        if SafeToGo then
                            if not entry.nosave then -- prevents an option that shouldn't have been saved from loading
                                player[entry.prop] = arg2
                                Success = true
                            end
                        end
                        if Success then
                            Leg = true
                        elseif entry.name != nil then
                            Name = entry.name
                        end
                    end
                end
            end
        end
    end
    if not Leg then
        CONS_Printf(player, "[\x89" .. "MMT" .. "\x80]\x85 Could not load option for \"" + Name .. "\"\x80!")
        player.ErrorLoading = true
    end
end)

-- [[ Super Shield Mobjs ]] --

addHook("MobjThinker", function(shield) -- there are so many .valid checks in here, when one goes down i need to patch another >:( don't whine at me for being lazy, blame the game for whining at me
	if not shield.valid return end
	local player
	if shield and shield.valid
		if not shield.target or not shield.target.valid then
			if shield.friendly and shield.friendly.valid then
				shield.friendly.TerminateSelf = true
			end
			P_RemoveMobj(shield)
			--mmtdebuggerPrint("target not found, delet this")
		end

		if shield.valid and shield.TerminateSelf then
		--or (shield.target.valid and shield.target.player.playerstate == PST_DEAD)
			if shield.friendly and shield.friendly.valid then
				shield.friendly.TerminateSelf = true
			end
			P_RemoveMobj(shield)
			--mmtdebuggerPrint("delet this")
		end
		
		if shield.valid and not shield.TerminateSelf then
			local player = shield.target.player
			if not shield.printed then
				--mmtdebuggerPrint("shield has been summoned")
				shield.printed = true
			end
		
			-- [ flip ] -- 
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				shield.flags2 = $1 | MF2_OBJECTFLIP
				shield.eflags = $1 | MFE_VERTICALFLIP
			else
				shield.flags2 = $ & ~MF2_OBJECTFLIP
				shield.eflags = $ & ~MFE_VERTICALFLIP
			end
			
			P_SetScale(shield, FixedMul(player.mo.scale, player.shieldscale))
			
			-- [ flop ] --
			if (shield.eflags & MFE_VERTICALFLIP) then
				shield.destinationz = player.mo.z + (player.mo.height - shield.height + FixedDiv(P_GetPlayerHeight(player) - player.mo.height, 3*FRACUNIT)) - FixedMul(2*FRACUNIT, player.mo.scale)
			else
				shield.destinationz = player.mo.z - (FixedDiv(P_GetPlayerHeight(player) - player.mo.height, 3*FRACUNIT)) + FixedMul(2*FRACUNIT, player.mo.scale)
			end
			
			P_TeleportMove(shield, player.mo.x, player.mo.y, shield.destinationz)
			
			
			if not shield.summonedfriend
				shield.friendly = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_FAKE_SHIELD2)
				shield.friendly.them = player.mo
				shield.friendly.target = shield
				shield.summonedfriend = true
			end
			
			if shield.PlayerShield != player.powers[pw_shield] and shield.SetState
				shield.SetState = false
				--mmtdebuggerPrint("unset false shield, prepping for new one")
			end
			
			--[[if (player.pflags & PF_SHIELDABILITY) and not shield.SetShieldAbility
				shield.SetShieldAbility = true
				shield.changesecondstate = true
				mmtdebuggerPrint("player used shield ability")
			end
			
			if (player.pflags & ~PF_SHIELDABILITY) and shield.SetShieldAbility
				shield.SetShieldAbility = false
				mmtdebuggerPrint("shield ability ended, unsetting shield.SetShieldAbility")
			end]]
			
			if not shield.DontRender
				if not shield.SetState
					if player.powers[pw_shield] == SH_WHIRLWIND then
						shield.state = S_WIND1
					elseif player.powers[pw_shield] == SH_PITY then
						shield.state = S_PITY1
					elseif player.powers[pw_shield] == SH_ARMAGEDDON then-- create seperate object for S_ARMF1
						shield.state = S_ARMA1
					elseif player.powers[pw_shield] == SH_PINK then -- change skincolor to pink in seperate function
						shield.state = S_PITY1
					elseif player.powers[pw_shield] == SH_ELEMENTAL then -- create seperate object for S_ELEMF1
						shield.state = S_ELEM1
					elseif player.powers[pw_shield] == SH_ATTRACT then
						shield.state = S_MAGN1
					elseif player.powers[pw_shield] == SH_FLAMEAURA then
						shield.state = S_FIRS1
					elseif player.powers[pw_shield] == SH_BUBBLEWRAP then
						shield.state = S_BUBS1
					elseif player.powers[pw_shield] == SH_THUNDERCOIN then
						shield.state = S_ZAPS1
					elseif player.powers[pw_shield] == SH_FORCE then
						shield.state = S_FORC11
					elseif player.powers[pw_shield] == SH_FORCE|1 then
						shield.state = S_FORC1
					elseif player.powers[pw_shield] == SH_NONE then
						shield.state = S_INVISIBLE
					end
					
					--mmtdebuggerPrint("set new state")
					if player.powers[pw_shield] == SH_PINK
						shield.color = SKINCOLOR_PINK
						shield.colorized = true
					else
						shield.color = SKINCOLOR_NONE
						shield.colorized = false
					end
					shield.changesecondstate = true
					shield.SetState = true
					shield.PlayerShield = player.powers[pw_shield]
				end
			else
				shield.state = S_INVISIBLE
			end
			
			if not (player.powers[pw_super] or player.powers[pw_invulnerability]) and not shield.DontRender
				--mmtdebuggerPrint("player no longer super, disabling render")
				shield.DontRender = true
			end
		end
	end
end, MT_FAKE_SHIELD)

addHook("MobjThinker", function(shield) 
	if not shield.valid return end

	local friend = shield.target

	if shield.TerminateSelf or not shield.them.valid or shield.them.player.playerstate == PST_DEAD then
		P_RemoveMobj(shield)
		--mmtdebuggerPrint("delet this 2")
	end

	local player
	if shield.valid and shield.them and shield.them.valid then
	    player = shield.them.player
	end


	if shield.valid and friend and not shield.TerminateSelf then
		
		if (friend.eflags & MFE_VERTICALFLIP)
			shield.flags2 = $1 | MF2_OBJECTFLIP
			shield.eflags = $1 | MFE_VERTICALFLIP
		else
			shield.flags2 = $ & ~MF2_OBJECTFLIP
			shield.eflags = $ & ~MFE_VERTICALFLIP
		end
	
	
		P_TeleportMove(shield, friend.x, friend.y, friend.z)
		
		if not shield.printed then
			--mmtdebuggerPrint("shield2 has been summoned")
			shield.printed = true
		end
		
		if not friend.DontRender then
			if friend.changesecondstate then
				if player.powers[pw_shield] == SH_ARMAGEDDON then-- create seperate object for S_ARMF1
					shield.state = S_ARMF1
				elseif player.powers[pw_shield] == SH_ELEMENTAL then -- create seperate object for S_ELEMF1
					shield.state = S_ELEMF1
				elseif player.powers[pw_shield] == SH_FLAMEAURA then
					shield.state = S_FIRSB1
				elseif player.powers[pw_shield] == SH_BUBBLEWRAP then
					shield.state = S_BUBSB1
				elseif player.powers[pw_shield] == SH_THUNDERCOIN then
					shield.state = S_ZAPSB1
				else
					shield.state = S_INVISIBLE
				end
				if friend.SetShieldAbility then
					if player.powers[pw_shield] == SH_FLAMEAURA then
						shield.state = mobjinfo[MT_FLAMEAURA_ORB].painstate -- idk how any of this shit works, i can't even find the state used for the shields, stjr plz 
					end
				end
				--mmtdebuggerPrint("change second state")
				friend.changesecondstate = false
			end
		else
			shield.state = S_INVISIBLE
		end
	end
end, MT_FAKE_SHIELD2)

-- [[ Score-Based Continues / Score Continues ]] --

addHook("IntermissionThinker", function(scorecont) local player = consoleplayer
    if player.ContinueHudDontRender then return end
	if not multiplayer and player.scorecontinues == "on" and player.scoretocalculate != nil then
		if S_IdPlaying(sfx_chchng) or S_IdPlaying(sfx_s3kb0) or S_IdPlaying(sfx_token) then
			if not player.GrantedContinue then
				if player.score - player.scoretocalculate >= 15000 then
					mmtdebuggerPrint(player.score - player.scoretocalculate)
					mmtdebuggerPrint("seY")
					player.continues = $ + 1
					player.GotContinue = true
					--S_StartSound(nil, sfx_s3kac, player)
				else
					mmtdebuggerPrint(player.score - player.scoretocalculate)
					player.GotContinue = false
				end
			end
			player.GrantedContinue = true
		end
	end
end)

local function ContinueHud(v, player) if multiplayer then return end
	local player = player
	if not player then
		player = displayplayer -- this also doesn't allow players for some reason >:( plz stjr
	end
	if player.ContinueHudDontRender then return end
    if player.scorecontinues == "off" then return end
	
	if not player.GotContinue
		v.timer = nil -- this will force reset everything
	else
		if v.timer == nil 
			v.timer = 0
			v.GravityY = -40
			v.bounces = 0
			v.momy = 20
		end
		v.timer = $ + 1
		local contsprite = v.getSprite2Patch(player.skincont, SPR2_XTRA, false, C)
		local COLOR = v.getColormap("sonic", player.colorcont)
		
		if v.bounces < 3 -- bounce code heavily inspired from SRB2's y_inter.c 's emeraldbounce code
			v.GravityY = $ + v.momy
			v.momy = $ + 1
			if v.GravityY > 161
				S_StartSound(nil, sfx_tink, player)
				v.bounces = $ + 1
				v.momy = -($/2)
				v.GravityY = 161
			end
		end
		
		v.YOffset = (5*(player.continues-1))
		if player.continues > 5
			v.YOffset = (5*(5-1))
		end
		
		
		mmtdebuggerPrint(v.GravityY .. " " .. v.bounces .. " " .. v.momy, true)
		v.draw(267, v.GravityY - v.YOffset, contsprite, nil, COLOR) -- do not snap to any direction, intermission hud doesn't do that. also, the Y to aim for is 161
	end
	
	-- [ render continues ] --
	local continuesrender = player.continues
	local extras
	if continuesrender > 4
		continuesrender = 4
		extras = player.continues - 4
	end
	if player.GotContinue then
		continuesrender = $ - 1
		if extras then
			continuesrender = $ + 1
			extras = player.continues - 5
		end
	end
	
	for i=continuesrender,1,-1 do
		local contsprite = v.getSprite2Patch(player.skincont, SPR2_XTRA, false, C)
		local COLOR = v.getColormap("sonic", player.colorcont)
		local PlacementY = 161 + 5
		
		v.draw(267, PlacementY - (5*i), contsprite, nil, COLOR)
		if extras thenyv.drawString(267+14, 156, "+ " +extras) end
	end
end

hud.add(ContinueHud, "intermission")

-- [[ Classic Shields ]] --

local function ChangeShield(classicshield)
	if MMTclassicshields == "on" then
		classicshield.prevname = classicshield.type
		if classicshield.type == MT_ATTRACT_BOX then
			classicshield.type = MT_THUNDERCOIN_BOX
		elseif classicshield.type == MT_ATTRACT_GOLDBOX then
			classicshield.type = MT_THUNDERCOIN_GOLDBOX

		elseif classicshield.type == MT_FORCE_BOX then
			classicshield.type = MT_BUBBLEWRAP_BOX
		elseif classicshield.type == MT_FORCE_GOLDBOX then
			classicshield.type = MT_BUBBLEWRAP_GOLDBOX

		elseif classicshield.type == MT_WHIRLWIND_BOX then
			classicshield.type = MT_THUNDERCOIN_BOX
		elseif classicshield.type == MT_WHIRLWIND_GOLDBOX then
			classicshield.type = MT_THUNDERCOIN_GOLDBOX

		elseif classicshield.type == MT_ARMAGEDDON_BOX then
			classicshield.type = MT_FLAMEAURA_BOX
		elseif classicshield.type == MT_ARMAGEDDON_GOLDBOX then
			classicshield.type = MT_FLAMEAURA_GOLDBOX

		elseif (classicshield.type == MT_ELEMENTAL_BOX or classicshield.type == MT_ELEMENTAL_GOLDBOX) then
			if mapheaderinfo[gamemap].lvlttl == "Deep Sea" or mapheaderinfo[gamemap].lvlttl == "Greenflower" or mapheaderinfo[gamemap].lvlttl == "Egg Rock" then
				--mmtdebuggerPrint("Map is water stage, and elemental shield detected, it's now bubble shield.")
				classicshield.ChangeType = MT_BUBBLEWRAP_BOX
			elseif mapheaderinfo[gamemap].lvlttl == "Red Volcano" then
				classicshield.ChangeType = MT_FLAMEAURA_BOX
				--mmtdebuggerPrint("Map is lava stage, and elemental shield detected, it's now fire shield.")
			else
				--mmtdebuggerPrint("Map name not detected, choosing random shield for elemental shield.")
				if P_RandomByte() < 127 then
					classicshield.ChangeType = MT_BUBBLEWRAP_BOX
				else
					classicshield.ChangeType = MT_FLAMEAURA_BOX
				end
			end

			if classicshield.type == MT_ELEMENTAL_GOLDBOX
				if classicshield.ChangeType == MT_BUBBLEWRAP_BOX
					classicshield.ChangeType = MT_BUBBLEWRAP_GOLDBOX
				else
					classicshield.ChangeType = MT_FLAMEAURA_GOLDBOX
				end
			end
			classicshield.type = classicshield.ChangeType
		end
	end
end

local function OnMonitorHit(classicshield, inflictor, source)
	if classicshield.prevname != nil then
		if source then
		source.player.ShieldPrevname = classicshield.prevname
		end
	end
end

local function RevertClassicShieldFunc(classicshield)
	if MMTclassicshields == "off" then
		if classicshield.prevname != nil
			classicshield.type = classicshield.prevname
		end
	end
end


addHook("MobjThinker", ChangeShield, MT_ATTRACT_BOX)
addHook("MobjThinker", ChangeShield, MT_ATTRACT_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_FORCE_BOX)
addHook("MobjThinker", ChangeShield, MT_FORCE_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_WHIRLWIND_BOX)
addHook("MobjThinker", ChangeShield, MT_WHIRLWIND_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_ARMAGEDDON_BOX)
addHook("MobjThinker", ChangeShield, MT_ARMAGEDDON_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_ELEMENTAL_BOX)
addHook("MobjThinker", ChangeShield, MT_ELEMENTAL_GOLDBOX)

addHook("MobjThinker", RevertClassicShieldFunc, MT_FLAMEAURA_BOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_BUBBLEWRAP_BOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_THUNDERCOIN_BOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_FLAMEAURA_GOLDBOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_BUBBLEWRAP_GOLDBOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_THUNDERCOIN_GOLDBOX)

addHook("MobjDeath", OnMonitorHit, MT_THUNDERCOIN_BOX)
addHook("MobjDeath", OnMonitorHit, MT_BUBBLEWRAP_BOX)
addHook("MobjDeath", OnMonitorHit, MT_FLAMEAURA_BOX)
addHook("MobjDeath", OnMonitorHit, MT_THUNDERCOIN_GOLDBOX)
addHook("MobjDeath", OnMonitorHit, MT_BUBBLEWRAP_GOLDBOX)
addHook("MobjDeath", OnMonitorHit, MT_FLAMEAURA_GOLDBOX)